
var graphdate = new Date();
var mode = 1; //1 = year, 2 = month, 3 = day
var currentkwh = 0;
var nodata = 0;
var locked = true;

////////////////////////////////////
// Initalisation function
////////////////////////////////////
function usagegraph() {

    graphdate.setHours(0);
    graphdate.setMinutes(0);
    graphdate.setSeconds(0);
    graphdate.setMilliseconds(0);

    $.ajaxSetup({cache: false});
    //initalise date selector

    $('#datepicker').on("hide", function (date) {
        graphdate = date['date'];

        getgraphdata();
    });

    //initialise buttons
    $("#graphprevious").click(function () {
        if (locked) {
            DisplayLocked()
        } else {
            if (mode === 1) {
                graphdate.setFullYear(graphdate.getFullYear() - 1);
            }
            if (mode === 2) {
                graphdate.setMonth(graphdate.getMonth() - 1);
            }
            if (mode === 3) {
                graphdate.setDate(graphdate.getDate() - 1);
            }

            $("#datepicker").datepicker("setDate", graphdate);

            getgraphdata();
        }
    });
    //initialise buttons
    $("#graphnext").click(function () {
        if (locked) {
            DisplayLocked()
        } else {
            if (mode === 1) {
                graphdate.setFullYear(graphdate.getFullYear() + 1);
            }
            if (mode === 2) {
                graphdate.setMonth(graphdate.getMonth() + 1);
            }
            if (mode === 3) {
                graphdate.setDate(graphdate.getDate() + 1);
            }

            $("#datepicker").datepicker("setDate", graphdate);

            getgraphdata();
        }

    });
    $("#graphmodeselection").change(function () {
        mode = parseInt($('#graphmodeselection').val());
        console.log("Mode changed to: " + mode);
        getgraphdata();
    });
    getgraphdata();
}

function getgraphdata() {

    $("#usagegraph").empty();
    $("#loader").show();
    locked = true;

    if (mode === 1) {
        $("#datepicker").datepicker('remove');

        $("#datepicker").datepicker({
            format: "yyyy",
            minViewMode: 2,
            maxViewMode: 2,
            todayHighlight: true,
            autoclose: true

        }
        )
        $("#datepicker").datepicker("setDate", graphdate);


        var year = graphdate.getFullYear();
        getyeardata(year);
    }
    if (mode === 2) {

        $("#datepicker").datepicker('remove');

        $("#datepicker").datepicker({
            format: "mm/yyyy",
            minViewMode: 1,
            maxViewMode: 2,
            todayHighlight: true,
            autoclose: true

        }
        )
        $("#datepicker").datepicker("setDate", graphdate);

        getmonthdata();
    }
    if (mode === 3) {

        $("#datepicker").datepicker('remove');

        $("#datepicker").datepicker({
            format: "dd/mm/yyyy",
            minViewMode: 0,
            maxViewMode: 2,
            todayHighlight: true,
            autoclose: true

        }
        )
        $("#datepicker").datepicker("setDate", graphdate);

        getdaydata();
    }

}

function DisplayLocked() {
    alert("Please wait for the graph to load!");
}

////////////////////////////////////
// Get data for a specific year
////////////////////////////////////
function getyeardata(year) {

    $.getJSON("../../../json.do?_VWH_MONTH[0..23],_WH_V[4]", function (data) {

        currentkwh = data['_WH_V'][0][0];
        var yeararray = [];
        var currentyear = new Date().getFullYear();
        var currentmonth = new Date().getMonth();
        var selyear = 0; //1 = two years ago, 2 = last year, 3= this year

        //check if selected year is current year
        if (year === currentyear) {
            selyear = 3;
        } else if (year === (currentyear - 1)) {
            selyear = 2;
        } else if (year === (currentyear - 2)) {
            selyear = 1;
        }

        if (selyear === 0) {
            nodata = 1;
        }

        //console.log("Selected year: " + selyear);
        //console.log("current month: " + currentmonth);
        //check if year is even or odd
        if (year % 2 === 0) {
            //loop through months
            for (var i = 0; i < 12; i++) {
                //check the following
                if (selyear === 3 && currentmonth >= i) {
                    yeararray.push([i + 1, data['_VWH_MONTH'][0][i]]);
                } else if (selyear === 2) {
                    yeararray.push([i + 1, data['_VWH_MONTH'][0][i]]);
                } else if (selyear === 1 && currentmonth < i) {
                    yeararray.push([i + 1, data['_VWH_MONTH'][0][i]]);
                } else {
                    yeararray.push([i + 1, 0]);
                }

            }
        } else {
            //loop through months
            for (var i = 0; i < 12; i++) {
                //check the following
                if (selyear === 3 && currentmonth >= i) {
                    yeararray.push([i + 1, data['_VWH_MONTH'][0][i + 12]]);
                } else if (selyear === 2) {
                    yeararray.push([i + 1, data['_VWH_MONTH'][0][i + 12]]);
                } else if (selyear === 1 && currentmonth < i) {
                    yeararray.push([i + 1, data['_VWH_MONTH'][0][i + 12]]);
                } else {
                    yeararray.push([i + 1, 0]);
                }
            }
        }

        drawgraph(yeararray);
    });
}

function getdaydata() {

	$.getJSON("../../../lib/get_time_info.html", function (data)
    {
        var systime = new Date(data["_SYSTIME"][0] * 1000);                                  
        var utctime = new Date(data["_UTCTIME"][0] * 1000);      
        var timezone =  (systime-utctime)/1000;
        
        var time = new Date(graphdate);
        time.setHours(0);
        time.setMinutes(0);
        time.setSeconds(0);
        time.setMilliseconds(0);
        time.setHours(time.getHours() - 1);
        
        var count = 30;
        var timebase = 3600.00;
        var parameter = "_WH_V[4]";
        var todaytotal = 0;
        
        var s = time.getTime();
        s = s / 1000;
        s = s + timezone;
        
        $.getJSON("hist_data/HIST_DATA.html", "val$=" + parameter + "&start=" + s + "&cnt=" + count + "&tb=" + timebase, function (data)
        {

            var length = data[parameter][0].length;
            var dayarray = new Array();
            var hour = 0;
            var hourtime = s;
            var previoushour = -1.11;
            var value = 0;
            nodata = 1;
            while (value < length && hour < 25) {                                                                     // => until the day is full or there is no more data       
                if (previoushour === -1.11) {                                                                         // => If no starthour               
                    if (data[parameter][0][value][1] === hourtime) {                                                  // => if valuetime = hourtime
                        previoushour = data[parameter][0][value][0];
                        hourtime = hourtime + 3600; // => increase hour
                        value++; // => increase value
                    } else if (data[parameter][0][value][1] > hourtime) {                                              // => if valuetime is later than hourtime
                        dayarray[hour] = 0; // => set barvalue 0
                        hourtime = hourtime + 3600; // => increase hour
                        hour++;
                    } else if (data[parameter][0][value][1] < hourtime) {                                              // => if valuetime is earlier than hourtime
                        value++; // => increase value
                    }
                } else {                                                                                              // => if starthour is set
                    if (data[parameter][0][value][1] === hourtime) {                                                  // => if valuetime = hourtime
                        nodata = 0;
                        dayarray[hour] = data[parameter][0][value][0] - previoushour; // => set barvalue
                        previoushour = data[parameter][0][value][0]; // => set previoushour 
                        todaytotal = todaytotal + dayarray[hour]; // => add to todaytotal
                        hourtime = hourtime + 3600; // => increase hour
                        hour++;
                        value++; // => increase value                  
                    } else if (data[parameter][0][value][1] > hourtime) {                                              // => if valuetime is later than hourtime
                        dayarray[hour] = 0; // => set barvalue 0
                        hourtime = hourtime + 3600; // => increase hour
                        hour++;
                        previoushour = -1.11; // => set previoushour null

                    } else if (data[parameter][0][value][1] < hourtime) {                                              // => if valuetime is earlier than hourtime
                        value++; // => increase value
                    }
                }
            }

            while (hour < 25) {                                                                                       // => until the day is full

                dayarray[hour] = 0;
                hour++;
            }

            var daydata = [];
            for (var i = 0; i < 24; i++) {
                daydata.push([i, dayarray[i]]);
            }

            drawgraph(daydata);
        }).error(function () {
            console.log("Failure requesting historical data");
        });
    });
}

////////////////////////////////////
// Get and calculate month data
////////////////////////////////////
function getmonthdata() {

	$.getJSON("../../../lib/get_time_info.html", function (data)
    {
        var systime = new Date(data["_SYSTIME"][0] * 1000);                                  
        var utctime = new Date(data["_UTCTIME"][0] * 1000);      
        var timezone =  (systime-utctime)/1000;
        		
        var time = new Date(graphdate);
        
        var dayscnt = daysInMonth(time);
        
		time.setDate(1);
		time.setHours(0, 0, 0, 0)
        time.setHours(time.getHours() - 1); 							//To compensate for Janitza storage time delay of 1 hour

        var count = 900;
        var timebase = 3600.00;
        var parameter = "_WH_V[4]";
        var todaytotal = 0;
		
        var s = time.getTime();
        s = s / 1000;
        s = s + timezone;
	
        nodata = 1;
		
	    $.getJSON("hist_data/HIST_DATA.html", "val$=" + parameter + "&start=" + s + "&cnt=" + count + "&tb=" + timebase, function (data)
	    {
	
			var dataitems 	= data[parameter][0].length;				//Number of data items in array
			var montharray	= new Array();								//Create array with usage data
			var starttime 	= s											//Start time of day
			var startkwh	= 0											//Start Usage of day
			var endkwh		= 0											//End Usage of Day
			
			//Check for data
			if(dataitems > 0){
				nodata = 0;
			}
			
			for(var day = 0 ; day <= dayscnt; day++){					//Loop Through days
			
				//Save previous kwh
				if(day > 0){
					startkwh = endkwh;
				}
			
				//Search for endkwh
				for(var item = 0; item < dataitems;item++){				//Loop Through dataarray
				
					endkwh = data[parameter][0][item][0];
				
					if(starttime === data[parameter][0][item][1]){		//Exact Timestamp
						endkwh = data[parameter][0][item][0];
						break;
					}

					if(starttime < data[parameter][0][item][1]){		//Higher Timestamp
						endkwh = data[parameter][0][item][0];
						break;
					}
				}
				
				//Calculate usage
				if(day > 0){
					var usage = endkwh - startkwh;
					montharray.push([day, usage]);
				}
				
				starttime = starttime + 3600 * 24;						//Next Day
			}
			drawgraph(montharray);
	    });
    }).error(function () {
        alert("Failure getting data");
    });
}



////////////////////////////////////
// Draw the graph
////////////////////////////////////
function drawgraph(d1) {

    if (nodata === 1) {
        $("#loader").hide();
        $('#usagegraph').empty();
        $('#usagegraph').html('<div style="text-align: center;top: 100px;font-weight: bold;position: relative;">' + tl('home.nodata') + '</div>');
        nodata = 0;
        locked = false;
    } else {
        var container = document.getElementById('usagegraph');
        Flotr.EventAdapter.stopObserving(container, 'flotr:select');
        Flotr.EventAdapter.stopObserving(container, 'flotr:click');
        $("#loader").hide();
        locked = false;
        var object = [];
        var count = 0;
        var y1label = '';
        var y2label = '';
        var datathere = false;
        var newdata = {};
        newdata['data'] = d1;
        newdata['color'] = '#337490';
        object.push(newdata);
        var options = {
            xaxis: {
                noTicks: 24, // Display 24 ticks.	 
                tickDecimals: 0,
                color: 'grey',
                tickFormatter: ticksdate
            },
            bars: {
                stacked: false,
                show: true,
                barWidth: 0.5,
                shadowSize: 0,
                fillOpacity: 1,
                lineWidth: 1
            },
            yaxis: {
                tickFormatter: tickskw,
                tickDecimals: 0,
                color: 'grey',
                min: 0
            }, grid: {
                color: 'grey', // => primary color used for outline and labels
                backgroundColor: null, // => null for transparent, else color
                backgroundImage: null, // => background image. String or object with src, left and top
                tickColor: '#DDDDDD', // => color used for the ticks
                labelMargin: 10, // => margin in pixels
                verticalLines: false, // => whether to show gridlines in vertical direction
                horizontalLines: true, // => whether to show gridlines in horizontal direction
                outlineWidth: 1      // => width of the grid outline/border in pixels
            },
            mouse: {
                track: true,
                relative: true,
                trackFormatter: function (obj) {
                    return Math.round(obj.y / 10) / 100 + " kWh";
                }
            }

        };
        // Draw graph with default options, overwriting with passed options


        function drawGraphhist(opts) {
            // Clone the options, so the 'options' variable always keeps intact.
            o = Flotr._.extend(Flotr._.clone(options), opts || {});
            // Return a new graph.
            flotrgraph = Flotr.draw(container, object, o);
        }


        //Make possibility to click in the graph
        Flotr.EventAdapter.observe(container, 'flotr:click', function (evt) {

            if (mode === 1) {
                console.log('click');
                var month = Math.round(evt.x);
                graphdate.setMonth(month - 1);
                $("#datepicker").datepicker("setDate", graphdate);
                $('#graphmodeselection').val(2);
                mode = 2;
                getgraphdata();
            } else if (mode === 2) {
                console.log('click');
                var day = Math.round(evt.x);
                graphdate.setDate(day);
                $("#datepicker").datepicker("setDate", graphdate);
                $('#graphmodeselection').val(3);
                mode = 3;
                getgraphdata();
            }


        });
        drawGraphhist();
    }

}

function tickskw(n) {
    return n / 1000 + " kWh";
}

function ticksdate(n) {
    if (mode === 1) {
        return tl("month" + n);
    }
    if (mode === 2 || mode === 3) {
        return n;
    }
}

function daysInMonth(anyDateInMonth) {
    return new Date(anyDateInMonth.getYear(),
            anyDateInMonth.getMonth() + 1,
            0).getDate();
}
